diff -Nur linux-2.6.9-intc1/drivers/net/wireless/Kconfig linux-2.6.9-intc1-mih1/drivers/net/wireless/Kconfig
--- linux-2.6.9-intc1/drivers/net/wireless/Kconfig	2004-10-18 17:53:43.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/net/wireless/Kconfig	2005-03-10 18:39:05.000000000 -0500
@@ -355,6 +355,74 @@
 	  say M here and read <file:Documentation/modules.txt>.  The module
 	  will be called prism54.ko.
 
+config HOSTAP
+	tristate "Host AP support for Prism2/2.5/3 IEEE 802.11b"
+	depends on NET_RADIO
+	---help---
+	A driver for 802.11b wireless cards based on Intersil Prism2/2.5/3
+	chipset. This driver supports so called Host AP mode that allows
+	the card to act as an IEEE 802.11 access point.
+
+	See <http://hostap.epitest.fi/> for more information about the
+	Host AP driver configuration and tools.
+
+	This option includes the base Host AP driver code that is shared by
+	different hardware models. You will also need to enable support for
+	PLX/PCI/CS version of the driver to actually use the driver.
+
+	The driver can be compiled as modules and they will be called
+	"hostap.o" and "hostap_crypt_wep.o".
+
+config HOSTAP_FIRMWARE
+	bool "Support downloading firmware images with Host AP driver"
+	depends on HOSTAP
+	---help---
+	Configure Host AP driver to include support for firmware image
+	download. Current version supports only downloading to volatile, i.e.,
+	RAM memory. Flash upgrade is not yet supported.
+
+	Firmware image downloading needs user space tool, prism2_srec. It is
+	available from http://hostap.epitest.fi/.
+
+config HOSTAP_PLX
+	tristate "Host AP driver for Prism2/2.5/3 in PLX9052 PCI adaptors"
+	depends on PCI && HOSTAP
+	---help---
+	Host AP driver's version for Prism2/2.5/3 PC Cards in PLX9052 based
+	PCI adaptors.
+
+	"Host AP support for Prism2/2.5/3 IEEE 802.11b" is required for this
+	driver and its help text includes more information about the Host AP
+	driver.
+
+	The driver can be compiled as a module and will be named
+	"hostap_plx.o".
+
+config HOSTAP_PCI
+	tristate "Host AP driver for Prism2.5 PCI adaptors"
+	depends on PCI && HOSTAP
+	---help---
+	Host AP driver's version for Prism2.5 PCI adaptors.
+
+	"Host AP support for Prism2/2.5/3 IEEE 802.11b" is required for this
+	driver and its help text includes more information about the Host AP
+	driver.
+
+	The driver can be compiled as a module and will be named
+	"hostap_pci.o".
+
+config HOSTAP_CS
+	tristate "Host AP driver for Prism2/2.5/3 PC Cards"
+	depends on PCMCIA!=n && HOSTAP
+	---help---
+	Host AP driver's version for Prism2/2.5/3 PC Cards.
+
+	"Host AP support for Prism2/2.5/3 IEEE 802.11b" is required for this
+	driver and its help text includes more information about the Host AP
+	driver.
+
+	The driver can be compiled as a module and will be named "hostap_cs.o".
+
 # yes, this works even when no drivers are selected
 config NET_WIRELESS
 	bool
diff -Nur linux-2.6.9-intc1/drivers/net/wireless/Makefile linux-2.6.9-intc1-mih1/drivers/net/wireless/Makefile
--- linux-2.6.9-intc1/drivers/net/wireless/Makefile	2004-10-18 17:55:36.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/net/wireless/Makefile	2005-03-10 18:39:05.000000000 -0500
@@ -28,6 +28,12 @@
 
 obj-$(CONFIG_PRISM54)		+= prism54/
 
+obj-$(CONFIG_HOSTAP)		+= hostap.o hostap_crypt_wep.o \
+					hostap_crypt_tkip.o hostap_crypt_ccmp.o
+obj-$(CONFIG_HOSTAP_CS)		+= hostap_cs.o
+obj-$(CONFIG_HOSTAP_PLX)	+= hostap_plx.o
+obj-$(CONFIG_HOSTAP_PCI)	+= hostap_pci.o
+
 # 16-bit wireless PCMCIA client drivers
 obj-$(CONFIG_PCMCIA_RAYCS)	+= ray_cs.o
 obj-$(CONFIG_PCMCIA_WL3501)	+= wl3501_cs.o
diff -Nur linux-2.6.9-intc1/drivers/pcmcia/Makefile linux-2.6.9-intc1-mih1/drivers/pcmcia/Makefile
--- linux-2.6.9-intc1/drivers/pcmcia/Makefile	2004-10-18 17:54:55.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/pcmcia/Makefile	2005-02-21 22:23:43.000000000 -0500
@@ -50,4 +50,5 @@
 
 pxa2xx_cs-$(CONFIG_ARCH_LUBBOCK)		+= pxa2xx_lubbock.o sa1111_generic.o
 pxa2xx_cs-$(CONFIG_MACH_MAINSTONE)		+= pxa2xx_mainstone.o
+pxa2xx_cs-$(CONFIG_MACH_GLENCOE)		+= pxa2xx_glencoe.o
 
diff -Nur linux-2.6.9-intc1/drivers/pcmcia/pxa2xx_base.c linux-2.6.9-intc1-mih1/drivers/pcmcia/pxa2xx_base.c
--- linux-2.6.9-intc1/drivers/pcmcia/pxa2xx_base.c	2004-10-18 17:55:43.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/pcmcia/pxa2xx_base.c	2005-04-21 20:52:45.000000000 -0400
@@ -140,7 +140,7 @@
 			       unsigned long val,
 			       struct cpufreq_freqs *freqs)
 {
-#warning "it's not clear if this is right since the core CPU (N) clock has no effect on the memory (L) clock"
+#warning "pcmcia_frequency_change: it's not clear if this is right since the core CPU (N) clock has no effect on the memory (L) clock"
 	switch (val) {
 	case CPUFREQ_PRECHANGE:
 		if (freqs->new > freqs->old) {
diff -Nur linux-2.6.9-intc1/drivers/pcmcia/pxa2xx_glencoe.c linux-2.6.9-intc1-mih1/drivers/pcmcia/pxa2xx_glencoe.c
--- linux-2.6.9-intc1/drivers/pcmcia/pxa2xx_glencoe.c	1969-12-31 19:00:00.000000000 -0500
+++ linux-2.6.9-intc1-mih1/drivers/pcmcia/pxa2xx_glencoe.c	2005-05-02 16:45:58.000000000 -0400
@@ -0,0 +1,184 @@
+/*
+ * linux/drivers/pcmcia/pxa2xx_glencoe.c
+ *
+ * Glencoe CompactFlash specific routines,
+ *  based on pxa2xx_mainstone.c by Nicolas Pitre
+ *  adapted for CompactFlash by Matthias Ihmig <m.ihmig@mytum.de>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/kernel.h>
+#include <linux/errno.h>
+#include <linux/interrupt.h>
+#include <linux/device.h>
+
+#include <pcmcia/ss.h>
+
+#include <asm/hardware.h>
+#include <asm/irq.h>
+
+#include <asm/arch/pxa-regs.h>
+#include <asm/arch/glencoe.h>
+
+#include "soc_common.h"
+
+
+static struct pcmcia_irqs irqs[] = {
+	{ 0, GLENCOE_S0_CD_IRQ, "CF0 CD" },
+	{ 1, GLENCOE_S1_CD_IRQ, "CF1 CD" },
+};
+
+static int gln_pcmcia_hw_init(struct soc_pcmcia_socket *skt)
+{
+	/*
+	 * Setup default state of GPIO outputs
+	 * before we enable them as outputs.
+	 */
+	GPSR(GPIO48_nPOE) =
+		GPIO_bit(GPIO48_nPOE) |
+		GPIO_bit(GPIO49_nPWE) |
+		GPIO_bit(GPIO50_nPIOR) |
+		GPIO_bit(GPIO51_nPIOW) |
+		GPIO_bit(GPIO85_nPCE_1) |
+		GPIO_bit(GPIO54_nPCE_2);
+
+	pxa_gpio_mode(GPIO48_nPOE_MD);
+	pxa_gpio_mode(GPIO49_nPWE_MD);
+	pxa_gpio_mode(GPIO50_nPIOR_MD);
+	pxa_gpio_mode(GPIO51_nPIOW_MD);
+	pxa_gpio_mode(GPIO85_nPCE_1_MD);
+	pxa_gpio_mode(GPIO54_nPCE_2_MD);
+	pxa_gpio_mode(GPIO79_pSKTSEL_MD);
+	pxa_gpio_mode(GPIO55_nPREG_MD);
+	pxa_gpio_mode(GPIO56_nPWAIT_MD);
+	pxa_gpio_mode(GPIO57_nIOIS16_MD);
+	
+	GPIO_clr(GLN_GPIO_CF_PWR_ON);
+	
+	pxa_gpio_mode(GLN_GPIO_nCF1_IRQ | GPIO_IN);
+	pxa_gpio_mode(GLN_GPIO_nCF2_IRQ | GPIO_IN);
+	pxa_gpio_mode(GLN_GPIO_nCF1_CARD_DET | GPIO_IN);
+	pxa_gpio_mode(GLN_GPIO_nCF2_CARD_DET | GPIO_IN);
+	
+	pxa_gpio_mode(GLN_GPIO_CF_PWR_ON | GPIO_OUT);
+	pxa_gpio_mode(GLN_GPIO_CF1_RST | GPIO_OUT);
+	pxa_gpio_mode(GLN_GPIO_CF2_RST | GPIO_OUT);
+	
+	GPIO_set(GLN_GPIO_CF_PWR_ON);
+
+	skt->irq = (skt->nr == 0) ? GLENCOE_S0_IRQ : GLENCOE_S1_IRQ;
+	return soc_pcmcia_request_irqs(skt, irqs, ARRAY_SIZE(irqs));
+}
+
+static void gln_pcmcia_hw_shutdown(struct soc_pcmcia_socket *skt)
+{
+	soc_pcmcia_free_irqs(skt, irqs, ARRAY_SIZE(irqs));
+	GPIO_clr(GLN_GPIO_CF_PWR_ON);
+}
+
+static void gln_pcmcia_socket_state(struct soc_pcmcia_socket *skt,
+				    struct pcmcia_state *state)
+{
+	if (skt->nr == 0) {
+		state->detect = (GPIO_lev(GLN_GPIO_nCF1_CARD_DET)) ? 0 : 1;
+		state->ready  = (GPIO_lev(GLN_GPIO_nCF1_IRQ))      ? 1 : 0;
+	} else {
+		state->detect = (GPIO_lev(GLN_GPIO_nCF2_CARD_DET)) ? 0 : 1;
+		state->ready  = (GPIO_lev(GLN_GPIO_nCF2_IRQ))      ? 1 : 0;
+	}
+	state->bvd1   = 1;
+	state->bvd2   = 1;
+	state->vs_3v  = 1;
+	state->vs_Xv  = 0;
+	state->wrprot = 0;  /* not available */
+}
+
+static int gln_pcmcia_configure_socket(struct soc_pcmcia_socket *skt,
+				       const socket_state_t *state)
+{
+	int ret = 0;
+	
+	GPIO_set(GLN_GPIO_CF_PWR_ON); /* no need to set voltage -> just switch power on */
+
+	printk(KERN_NOTICE "%s(): configuring sockekt %u, Vcc=%u, Vpp=%u\n",
+					  __FUNCTION__, skt->nr, state->Vcc, state->Vpp);
+	
+	ret = -1;
+	if (skt->nr == 0) {
+		if (state->flags & SS_RESET)
+			GPIO_set(GLN_GPIO_CF1_RST);
+		else 
+			GPIO_clr(GLN_GPIO_CF1_RST);
+		ret = 0;
+	};
+	if (skt->nr == 1) {
+		if (state->flags & SS_RESET)
+			GPIO_set(GLN_GPIO_CF2_RST);
+		else 
+			GPIO_clr(GLN_GPIO_CF2_RST);
+		ret = 0;
+	}
+
+	return ret;
+}
+
+static void gln_pcmcia_socket_init(struct soc_pcmcia_socket *skt)
+{
+}
+
+static void gln_pcmcia_socket_suspend(struct soc_pcmcia_socket *skt)
+{
+}
+
+static struct pcmcia_low_level gln_pcmcia_ops = {
+	.owner			= THIS_MODULE,
+	.hw_init		= gln_pcmcia_hw_init,
+	.hw_shutdown		= gln_pcmcia_hw_shutdown,
+	.socket_state		= gln_pcmcia_socket_state,
+	.configure_socket	= gln_pcmcia_configure_socket,
+	.socket_init		= gln_pcmcia_socket_init,
+	.socket_suspend		= gln_pcmcia_socket_suspend,
+	.nr			= 2,
+};
+
+static struct platform_device *gln_pcmcia_device;
+
+static int __init gln_pcmcia_init(void)
+{
+	int ret;
+
+	gln_pcmcia_device = kmalloc(sizeof(*gln_pcmcia_device), GFP_KERNEL);
+	if (!gln_pcmcia_device)
+		return -ENOMEM;
+	memset(gln_pcmcia_device, 0, sizeof(*gln_pcmcia_device));
+	gln_pcmcia_device->name = "pxa2xx-pcmcia";
+	gln_pcmcia_device->dev.platform_data = &gln_pcmcia_ops;
+
+	ret = platform_device_register(gln_pcmcia_device);
+	if (ret)
+		kfree(gln_pcmcia_device);
+
+	return ret;
+}
+
+static void __exit gln_pcmcia_exit(void)
+{
+	/*
+	 * This call is supposed to free our gln_pcmcia_device.
+	 * Unfortunately platform_device don't have a free method, and
+	 * we can't assume it's free of any reference at this point so we
+	 * can't free it either.
+	 */
+	platform_device_unregister(gln_pcmcia_device);
+}
+
+module_init(gln_pcmcia_init);
+module_exit(gln_pcmcia_exit);
+
+MODULE_AUTHOR("Matthias Ihmig <m.ihmig@mytum.de>");
+MODULE_LICENSE("GPL");
diff -Nur linux-2.6.9-intc1/drivers/serial/pxa.c linux-2.6.9-intc1-mih1/drivers/serial/pxa.c
--- linux-2.6.9-intc1/drivers/serial/pxa.c	2005-05-02 15:16:11.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/serial/pxa.c	2005-05-01 14:54:02.000000000 -0400
@@ -48,8 +48,8 @@
 
 #include <linux/serial_core.h>
 
-#ifdef	CONFIG_PXA27x
-#include <asm/arch/mainstone.h>
+#ifdef CONFIG_MACH_MAINSTONE
+	#include <asm/arch/mainstone.h>
 #endif
 
 struct uart_pxa_port {
@@ -396,6 +396,16 @@
 }
 #endif
 
+static void
+serial_pxa_pm(struct uart_port *port, unsigned int state,
+	      unsigned int oldstate)
+{
+	struct uart_pxa_port *up = (struct uart_pxa_port *)port;
+	pxa_set_cken(up->cken, !state);
+	if (!state)
+		udelay(1);
+}
+
 static int serial_pxa_startup(struct uart_port *port)
 {
 	struct uart_pxa_port *up = (struct uart_pxa_port *)port;
@@ -411,18 +421,35 @@
 	if (retval)
 		return retval;
 
-/* This enable the BTUART. FFUART has been enabled in bootloader.
- * STUART will be enabled in IrDA driver. Put these codes after
- * request irq successful.
- */
+	/* Enable the requested serial port. Don't rely on previous activation, that might
+	 * not have taken place - just do it here.
+	 * Put these codes after request irq is successful.
+	 */
+
+	if ( IRQ_FFUART == up->port.irq) {
+		pxa_gpio_mode(GPIO34_FFRXD_MD);
+		pxa_gpio_mode(GPIO35_FFCTS_MD);
+		pxa_gpio_mode(GPIO36_FFDCD_MD);
+		pxa_gpio_mode(GPIO37_FFDSR_MD);
+		pxa_gpio_mode(GPIO38_FFRI_MD);
+		pxa_gpio_mode(GPIO39_FFTXD_MD);
+		pxa_gpio_mode(GPIO40_FFDTR_MD);
+		pxa_gpio_mode(GPIO41_FFRTS_MD);
+	}
 	if ( IRQ_BTUART == up->port.irq) {
+#ifdef CONFIG_MACH_MAINSTONE
 		MST_MSCWR1 |= (0x03<<7);
-		CKEN |= CKEN7_BTUART;
+#endif
 		pxa_gpio_mode(GPIO42_BTRXD_MD);
 		pxa_gpio_mode(GPIO43_BTTXD_MD);
 		pxa_gpio_mode(GPIO44_BTCTS_MD);
 		pxa_gpio_mode(GPIO45_BTRTS_MD);
 	}
+	if ( IRQ_STUART == up->port.irq) {
+		pxa_gpio_mode(GPIO46_STRXD_MD);
+		pxa_gpio_mode(GPIO47_STTXD_MD);
+	}
+	serial_pxa_pm((struct uart_port *)up, 0, 0);		// enable clock
 
 	/*
 	 * Clear the FIFO buffers and disable them.
@@ -605,16 +632,6 @@
 	spin_unlock_irqrestore(&up->port.lock, flags);
 }
 
-static void
-serial_pxa_pm(struct uart_port *port, unsigned int state,
-	      unsigned int oldstate)
-{
-	struct uart_pxa_port *up = (struct uart_pxa_port *)port;
-	pxa_set_cken(up->cken, !state);
-	if (!state)
-		udelay(1);
-}
-
 static void serial_pxa_release_port(struct uart_port *port)
 {
 }
